package jogo;

import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import javax.swing.JOptionPane;

public class ClienteThread extends Thread {

    private Principal pai;
    private ObjectOutputStream saida;
    private ObjectInputStream entrada;
    private String nome, IP;
    private int porta;
    private Mensagem msg, recebida;
    private boolean conectado;

    ClienteThread(Principal aThis, String IP, int porta, String n) {
        this.pai = aThis;
        this.nome = n;
        this.IP = IP;
        this.porta = porta;
    }

    public void enviarMensagem(Mensagem msg) {
        try {
            saida.writeObject(msg);
        } catch (Exception ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }
    }

    public void setConectado(boolean co) {
        this.conectado = co;
    }

    @Override
    public void run() {
        Socket conexao = null;

        try {
            conexao = new Socket(IP, porta);
            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());
            conectado = true;
            msg = new Mensagem(100, nome);
            saida.writeObject(msg);
            while (conectado) {
                recebida = (Mensagem) entrada.readObject();
                System.err.println("(" + recebida.getCodigo() + ")Mensagem do servidor: " + recebida.getValor());
                pai.MensagemRecebida(recebida);

                if (msg.getCodigo() == 101) {
                    conectado = false;
                }

            }

            // fechando os fluxos e a conexao
            saida.close();
            entrada.close();
            conexao.close();
        } catch (EOFException e) {
            try {
                saida.close();
                entrada.close();
                conexao.close();
                pai.MensagemRecebida(new Mensagem(101, "fim"));
            } catch (Exception ex) {
                System.err.println("Erro desconectar sockets(ClienteThread): " + ex.toString());
            }
        } catch (java.net.ConnectException e) {
            JOptionPane.showMessageDialog(null,"Conexão Recusada!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
        } catch (Exception ex) {
            System.err.println("Erro sockets(ClienteThread): " + ex.toString());
        }
    }
}
