package jogo;

import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author diogo
 */
public class Maquina extends Thread {

    private ObjectOutputStream saida;
    private ObjectInputStream entrada;
    private String nome;
    private Mensagem msg, recebida;
    private boolean conectado = false;
    private int escolhida = 0;
    String[] carta = new String[4];

    public void enviarMensagem(Mensagem msg) {
        try {
            saida.writeObject(msg);
        } catch (Exception ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }
    }

    public void run() {
        Socket conexao = null;
        nome = "Computador";

        try {
            conexao = new Socket("127.0.0.1", 63001);
            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());
            conectado = true;
            msg = new Mensagem(100, nome);
            saida.writeObject(msg);
            while (conectado) {
                try {
                    recebida = (Mensagem) entrada.readObject();
                    try {
                        Thread.sleep(100);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(Maquina.class.getName()).log(Level.SEVERE, null, ex);
                    }
                } catch (ClassNotFoundException ex) {
                    Logger.getLogger(Maquina.class.getName()).log(Level.SEVERE, null, ex);
                }
                System.err.println("(" + recebida.getCodigo() + ")Mensagem do servidor para PC: " + recebida.getValor());
                int cod = recebida.getCodigo();

                switch (cod) {
                    case 101:
                        conectado = false;
                        break;
                    case 200: // disctribuir cartas
                        carta = new String[4];
                        String cartas = recebida.getValor();
                        carta[0] = "" + cartas.charAt(0) + cartas.charAt(1);
                        carta[1] = "" + cartas.charAt(3) + cartas.charAt(4);
                        carta[2] = "" + cartas.charAt(6) + cartas.charAt(7);
                        carta[3] = "" + cartas.charAt(9) + cartas.charAt(10);
                        escolhida = 0;
                        break;

                    case 201: //de quem eh a vez
                        if (recebida.getValor().equals("yes")) {
                            /*try {
                                Thread.sleep(600);
                            } catch (InterruptedException ex) {
                                Logger.getLogger(Maquina.class.getName()).log(Level.SEVERE, null, ex);
                            }*/
                            this.enviarMensagem(new Mensagem(210, (carta[escolhida])));
                            escolhida++;
                        } else {
                            if (escolhida < 2) {
                                escolhida++;
                            } else {
                                escolhida = 0;
                            }
                        }
                        break;
                    case 500:
                       /* try {
                            Thread.sleep(1000);
                        } catch (InterruptedException ex) {
                            Logger.getLogger(Maquina.class.getName()).log(Level.SEVERE, null, ex);
                        }*/
                        escolhida = 0;
                        break;
                    case 550:
                        conectado = false;
                        Mensagem fim = new Mensagem(101, "Fechei");
                        this.enviarMensagem(fim);
                        break;
                    case 666:
                        if (recebida.getValor().equals("Truco!")) {
                            this.enviarMensagem(new Mensagem(666, "Aceitou!"));
                            escolhida = 0;
                        }
                        break;
                }// fim do switch(cod)
            }

            // fechando os fluxos e a conexao
            saida.close();
            entrada.close();
            conexao.close();
        } catch (EOFException e) {
        } catch (IOException ex) {
        }
    }
}
