/*
 * Principal.java
 *
 * Created on 19/05/2011, 09:44:35
 * License: GPLv3
 */
package jogo;

import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Emerson Ribeiro de Mello, Diogo luiz da Silva
 */
public class Principal extends javax.swing.JFrame {

    private boolean conectado = false;
    private ClienteThread ct;
    private ArrayList<Carta> baralho;
    private int posicialInicialX;// coordenada X onde deve aparecer a 1a. carta
    private int posicialInicialY;// coordenada Y onde deve aparecer a 1a. carta
    private boolean servidor;
    private String apelido;
    private int porta, cod;
    private String IP;
    private boolean minhaVez;
    private boolean trucado;
    private int valorTruco;
    private boolean maquina = false;
    private String apelidoOponente;
    private boolean respTruco;
    private String cartas;

    /** Creates new form Principal */
    public Principal() {
        this.posicialInicialX = 5;
        this.posicialInicialY = 5;
        this.baralho = new ArrayList<Carta>();
        this.criaBaralho();

        initComponents();
        this.setLocationRelativeTo(null);
    }

    /**
     * Cria as cartas e adiciona no baralho
     * Adaptado de:
     * Fred Swartz - February 19, 2007 - Placed in public domain.
     */
    private void criaBaralho() {

        String naipe = "oecp";
        String frente = "1234567djq";
        int pos = 0;
        int px = this.posicialInicialX;
        int py = this.posicialInicialY;

        this.baralho.clear();
        //baralho = new ArrayList<Carta>();

        for (int n = 0; n < naipe.length(); n++) {
            for (int f = 0; f < frente.length(); f++) {
                String caminho = "" + frente.charAt(f) + naipe.charAt(n) + ".png";
                // true para carta com o verso aparecendo
                // false para aparecer a frente da carta
                Carta ca = new Carta(f, n, caminho, false, false);
                ca.mover(9999, 9999);
                px += 9999;
                py += 9999;
                this.baralho.add(ca);
            }
        }
    }

    public int getPosicialInicialX() {
        return posicialInicialX;
    }

    public int getPosicialInicialY() {
        return posicialInicialY;
    }

    public String getApelido() {
        return apelido;
    }

    public void setApelido(String apelido) {
        this.apelido = apelido;
    }

    public int getPorta() {
        return porta;
    }

    public void setPorta(int porta) {
        this.porta = porta;
    }

    public String getIP() {
        return IP;
    }

    public void setIP(String IP) {
        this.IP = IP;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPMesa = new Mesa(this, this.baralho);
        jPLateral = new javax.swing.JPanel();
        jBEmbaralhar = new javax.swing.JButton();
        jBVirarCartas = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLApelido = new javax.swing.JLabel();
        jLMeusPontos = new javax.swing.JLabel();
        jLPontosOponente = new javax.swing.JLabel();
        jBAcao = new javax.swing.JButton();
        status = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        resultado1 = new javax.swing.JLabel();
        resultado2 = new javax.swing.JLabel();
        resultado3 = new javax.swing.JLabel();
        jLcaixa = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMCriar = new javax.swing.JMenuItem();
        jMEntrar = new javax.swing.JMenuItem();
        jMSair = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Jogo de Truco - Diogo Luiz da Silva");
        setBackground(new java.awt.Color(1, 1, 1));
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                Fechar(evt);
            }
        });

        jPMesa.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout jPMesaLayout = new javax.swing.GroupLayout(jPMesa);
        jPMesa.setLayout(jPMesaLayout);
        jPMesaLayout.setHorizontalGroup(
            jPMesaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 548, Short.MAX_VALUE)
        );
        jPMesaLayout.setVerticalGroup(
            jPMesaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 430, Short.MAX_VALUE)
        );

        jPLateral.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jBEmbaralhar.setText("Enviar");
        jBEmbaralhar.setEnabled(false);
        jBEmbaralhar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBEmbaralharActionPerformed(evt);
            }
        });

        jBVirarCartas.setText("Enviar carta virada");
        jBVirarCartas.setEnabled(false);
        jBVirarCartas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBVirarCartasActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Pontuação"));

        jLabel1.setText("Você:");

        jLApelido.setText("Oponente:");

        jLMeusPontos.setText("0");

        jLPontosOponente.setText("0");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLMeusPontos))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLApelido)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLPontosOponente)))
                .addContainerGap(77, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLMeusPontos))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLApelido)
                    .addComponent(jLPontosOponente))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jBAcao.setText("Truco!");
        jBAcao.setEnabled(false);
        jBAcao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAcaoActionPerformed(evt);
            }
        });

        jLabel2.setText("Rodada 1:");

        jLabel3.setText("Rodada 2:");

        jLabel4.setText("Rodada 3:");

        jLcaixa.setForeground(new java.awt.Color(255, 0, 0));

        javax.swing.GroupLayout jPLateralLayout = new javax.swing.GroupLayout(jPLateral);
        jPLateral.setLayout(jPLateralLayout);
        jPLateralLayout.setHorizontalGroup(
            jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPLateralLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jBEmbaralhar, javax.swing.GroupLayout.DEFAULT_SIZE, 179, Short.MAX_VALUE)
                    .addComponent(jBVirarCartas, javax.swing.GroupLayout.DEFAULT_SIZE, 179, Short.MAX_VALUE)
                    .addComponent(jBAcao, javax.swing.GroupLayout.DEFAULT_SIZE, 179, Short.MAX_VALUE)
                    .addComponent(status)
                    .addGroup(jPLateralLayout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(resultado1))
                    .addGroup(jPLateralLayout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(resultado2))
                    .addGroup(jPLateralLayout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(resultado3))
                    .addComponent(jLcaixa))
                .addContainerGap())
        );
        jPLateralLayout.setVerticalGroup(
            jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPLateralLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jBAcao)
                .addGap(18, 18, 18)
                .addComponent(status)
                .addGap(37, 37, 37)
                .addComponent(jLcaixa)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 64, Short.MAX_VALUE)
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(resultado1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(resultado2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(resultado3))
                .addGap(18, 18, 18)
                .addComponent(jBVirarCartas)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBEmbaralhar)
                .addContainerGap())
        );

        jMenu1.setText("Jogo");

        jMCriar.setText("Criar jogo");
        jMCriar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMCriarActionPerformed(evt);
            }
        });
        jMenu1.add(jMCriar);

        jMEntrar.setText("Entrar em jogo");
        jMEntrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMEntrarActionPerformed(evt);
            }
        });
        jMenu1.add(jMEntrar);

        jMSair.setText("Sair");
        jMSair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMSairActionPerformed(evt);
            }
        });
        jMenu1.add(jMSair);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Ajuda");

        jMenuItem1.setText("Manual");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem1);

        jMenuItem2.setText("Sobre");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem2);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPMesa, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPLateral, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPMesa, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPLateral, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

   private void jBEmbaralharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBEmbaralharActionPerformed
       for (Carta c : baralho) { // Enviar carta
           if (c.getEscolhida() && this.isMinhaVez() /*&& !this.isRespTruco()*/) {
               if (this.getMeusPontos().equals("11") && this.getPontosOponente().equals("11")) {
                   c.virar();
               }
               ct.enviarMensagem(new Mensagem(210, (c.getValor() + c.getNaipe())));
           }
       }
       this.setBotoes(false);
       ((Mesa) this.jPMesa).repaint();
   }//GEN-LAST:event_jBEmbaralharActionPerformed

   private void jBVirarCartasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBVirarCartasActionPerformed
       ((Mesa) this.jPMesa).virarCartas(); //Enviar carta virada
       for (Carta c : baralho) { // Enviar carta
           if (c.getEscolhida() && this.isMinhaVez() /*&& !this.isRespTruco()*/) {
               ct.enviarMensagem(new Mensagem(210, "00")); //String virada diz q o jogador pulou a vez
               c.setDesenhar(false);
           }
       }
       for (Carta c : baralho) {
           if (c.isEscolhidaOponente()) {
               c.setDesenhar(false);
           }
       }
       this.setBotoes(false);
       ((Mesa) this.jPMesa).repaint();
   }//GEN-LAST:event_jBVirarCartasActionPerformed

   private void jMCriarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMCriarActionPerformed
       Criarjogo jp = new Criarjogo(this, true, this);
       jp.setLocationRelativeTo(this);
       jp.setVisible(true);

       if (servidor) {
           this.EntrarEmJogo("127.0.0.1", porta, apelido);
       }
       if (maquina) {
           try {
               Thread.sleep(100);
           } catch (InterruptedException ex) {
               Logger.getLogger(Principal.class.getName()).log(Level.SEVERE, null, ex);
           }
           Maquina mq = new Maquina();
           mq.start();
       }
   }//GEN-LAST:event_jMCriarActionPerformed

   private void jMEntrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMEntrarActionPerformed
       EntrarJogo jp = new EntrarJogo(this, true, this);
       jp.setLocationRelativeTo(this);
       jp.setVisible(true);
       if (jp.isEntrar()) {
           System.err.println("IP: " + IP + " porta: " + porta);
           if (!servidor) {
               this.EntrarEmJogo(IP, porta, apelido);
           }
       }
   }//GEN-LAST:event_jMEntrarActionPerformed

   private void Fechar(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_Fechar
       int op = JOptionPane.showConfirmDialog(null, "Deseja realmente sair?", "", JOptionPane.YES_NO_OPTION);

       if (op == JOptionPane.YES_OPTION) {
           if (conectado) {
               Mensagem fim = new Mensagem(101, "Fechei");
               ct.enviarMensagem(fim);
               ct.setConectado(false);
           }
           System.exit(0);
       }
   }//GEN-LAST:event_Fechar

   private void jBAcaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAcaoActionPerformed
       if (!trucado) {
           if (this.isMinhaVez() /*&& !this.isRespTruco()*/) {
               ct.enviarMensagem(new Mensagem(666, "Truco!"));
               this.setBotoes(false);
           }
           respTruco = true;
           jBAcao.setEnabled(false);
       }
   }//GEN-LAST:event_jBAcaoActionPerformed

   private void jMSairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMSairActionPerformed
       int op = JOptionPane.showConfirmDialog(null, "Deseja realmente sair?", "", JOptionPane.YES_NO_OPTION);

       if (op == JOptionPane.YES_OPTION) {
           if (conectado) {
               Mensagem fim = new Mensagem(101, "Fechei");
               ct.enviarMensagem(fim);
               ct.setConectado(false);
           }
           System.exit(0);
       }
   }//GEN-LAST:event_jMSairActionPerformed

   private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
       JOptionPane.showMessageDialog(this, "Jogo de Truco!\nAutor: Diogo Luiz da Silva.\nProjeto Final de POO!", "Sobre", JOptionPane.INFORMATION_MESSAGE);
   }//GEN-LAST:event_jMenuItem2ActionPerformed

   private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
       jDManual jp = new jDManual(this, true);
       jp.setLocationRelativeTo(this);
       jp.setVisible(true);
   }//GEN-LAST:event_jMenuItem1ActionPerformed

    public void setServidor(boolean a) {
        servidor = a;
    }

    public boolean getServidor() {
        return this.servidor;
    }

    private void EntrarEmJogo(String IP, int porta, String apelido) {
        ct = new ClienteThread(this, IP, porta, apelido);
        ct.start();
    }

    public void MensagemRecebida(Mensagem recebida) {
        cod = recebida.getCodigo();

        switch (cod) {
            case 100:
                conectado = true;
                jMCriar.setEnabled(false);
                jMEntrar.setEnabled(false);
                if (!recebida.getValor().equals("")) {
                    apelidoOponente = recebida.getValor();
                    jLApelido.setText(recebida.getValor() + ":");
                    JOptionPane.showMessageDialog(this, "Jogando contra " + recebida.getValor() + "!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                } else {
                    this.status.setText("Aguarde outro jogador!");
                }
                for (Carta c : baralho) {
                    c.setOponente(false);
                    c.setDesenhar(false);
                    ((Mesa) this.jPMesa).repaint();
                }
                break;
            case 101:
                JOptionPane.showMessageDialog(this, "O outro jogador se desconectou!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                conectado = false;
                jMCriar.setEnabled(true);
                jMEntrar.setEnabled(true);
                for (Carta c : baralho) {
                    c.setOponente(false);
                    c.setDesenhar(false);
                    ((Mesa) this.jPMesa).repaint();
                }
                this.jLMeusPontos.setText("");
                this.jLPontosOponente.setText("");
                this.status.setText("");
                this.setBotoes(false);
                System.exit(0);
                break;
            case 200: // disctribuir cartas
                for (Carta c : baralho) {
                    c.setEscolhida(false);
                    c.setDesenhar(false);
                    c.setEscolhidaOponente(false);
                    c.setOponente(false);
                    c.setX(9999);
                }
                this.valorTruco = 0;
                cartas = recebida.getValor();
                String[] carta = new String[4]; // cartas.split(":");
                carta[0] = "" + cartas.charAt(0) + cartas.charAt(1);
                carta[1] = "" + cartas.charAt(3) + cartas.charAt(4);
                carta[2] = "" + cartas.charAt(6) + cartas.charAt(7);
                carta[3] = "" + cartas.charAt(9) + cartas.charAt(10);
                for (int i = 0; i <= 3; i++) {
                    ((Mesa) this.jPMesa).desenharCartas(carta[i], i);
                }
                int i = 0;
                //Desenha cartas viradas do oponente
                int largura = ((Mesa) this.jPMesa).getWidth();
                int p = 20;
                int larguraCarta = (baralho.get(0)).getLargura();
                int x1,
                 x2,
                 y1;

                x2 = (largura / 2) - (larguraCarta / 2);
                x1 = x2 - (p + larguraCarta);
                for (Carta c : baralho) {//FAZER POSICAO
                    if (i < 3) {
                        if (!c.isDesenhar()) {
                            switch (i) {
                                case 0:
                                    c.setX(x1);
                                    break;
                                case 1:
                                    c.setX(x2);
                                    break;
                                case 2:
                                    c.setX(x2 + (larguraCarta + p));
                                    break;
                            }
                            c.setY(p);
                            c.virar();
                            c.setOponente(true);
                            c.setDesenhar(true);
                            i++;
                        }
                    }
                }
                ((Mesa) this.jPMesa).repaint();
                break;

            case 201: //de quem eh a vez
                if (recebida.getValor().equals("yes")) {
                    this.minhaVez = true;
                    this.status.setText("Sua vez!");
                    this.setBotoes(false);
                    if (!trucado) {
                        this.jBAcao.setEnabled(true);
                    }
                } else {
                    this.minhaVez = false;
                    this.status.setText("É a vez do outro jogador!");
                    this.setBotoes(false);
                }
                ((Mesa) this.jPMesa).repaint();
                break;
            case 210: //carta do outro jogador
                if (recebida.getValor().equals("00")) {
                    JOptionPane.showMessageDialog(this, "O outro jogador escondeu sua carta!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                    for (Carta c : baralho) {
                        if (c.getOponente() && c.isVirada()) {
                            c.setEscolhidaOponente(true);
                            c.setValor("0");
                            c.setNaipe("0");
                            c.setY(c.getY() + 100);
                            break;
                        }
                    }
                } else {
                    int px = 0;
                    int py = 0;
                    boolean cartaJ = false;
                    for (Carta c : baralho) {
                        if (c.getOponente() && c.isVirada()) {
                            if (recebida.getValor().equals(c.getValor() + c.getNaipe())) {
                                c.setOponente(false);
                                c.virar();
                                c.setOponente(true);
                                c.setY(c.getY() + 100);
                                c.setEscolhidaOponente(true);
                                cartaJ = true;
                                break;
                            }
                        }
                    }
                    if (!cartaJ) {
                        for (Carta c : baralho) {
                            if (c.getOponente() && c.isVirada()) {
                                c.setOponente(false);
                                c.setDesenhar(false);
                                c.virar();
                                px = c.getX();
                                py = c.getY();
                                break;
                            }
                        }
                        for (Carta c : baralho) {
                            if (recebida.getValor().equals(c.getValor() + c.getNaipe())) {
                                if (c.getOponente()) {
                                    c.virar();
                                    c.setX(px);
                                    c.setY(c.getY() + 100);
                                    c.setEscolhidaOponente(true);
                                } else {
                                    c.setX(px);
                                    c.setY(py + 100);
                                    c.setDesenhar(true);
                                    c.setOponente(true);
                                    c.setEscolhidaOponente(true);
                                }
                            }
                        }
                    }
                }
                System.err.println("teste");
               ((Mesa) this.jPMesa).repaint();
                break;
            case 202: //rodada 
                /*
                 *  "0:"texto" - primeira rodada
                 *  "1:texto" - segunda rodada e o resultado da rodada anterior
                 *  "2:texto" - Terceira rodada com o resultado da rodada anterior
                 */

                if (recebida.getValor().equals("0")) {
                    this.resultado1.setText("Acontecendo!");
                    this.resultado2.setText("");
                    this.resultado3.setText("");
                } else {
                    String[] ro = (recebida.getValor()).split(":");

                    if (ro[0].equals("0")) {
                        this.resultado1.setText(ro[1]);
                        this.resultado2.setText("Acontecendo!");
                        this.resultado3.setText("");

                    }
                    if (ro[0].equals("1")) {
                        this.resultado2.setText(ro[1]);
                        this.resultado3.setText("Acontecendo!");
                    }

                }

                for (Carta c : baralho) {
                    if (c.isEscolhidaOponente()) {
                        c.setDesenhar(false);
                        c.setX(9999);
                    }
                    if (c.getEscolhida()) {
                        c.setDesenhar(false);
                        c.setX(9999);
                    }
                }
                break;
            case 500:
                /*
                 * yes - ganhei uma rodada simples
                 * no - perdi uma rodada simples
                 * empate - rodada empatou
                 * "yes:valor" - ganhei um truco valendo 'valor'
                 * "no:valor" - perdi um truco valendo 'valor'
                 */
                if (recebida.getValor().equals("yes")) {
                    JOptionPane.showMessageDialog(this, "Sua carta é maior!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                    this.jLcaixa.setText("Sua carta é maior!");
                }
                if (recebida.getValor().equals("no")) {
                    JOptionPane.showMessageDialog(this, "Sua carta é menor!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                    this.jLcaixa.setText("Sua carta é menor!");
                }
                if (recebida.getValor().equals("empate")) {
                    JOptionPane.showMessageDialog(this, "Empatou!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                    this.jLcaixa.setText("Empatou!");
                }
                for (Carta c : baralho) {
                    if (c.isEscolhidaOponente()) {
                        c.setDesenhar(false);
                        c.setX(9999);
                    }
                    if (c.getEscolhida()) {
                        c.setDesenhar(false);
                        c.setX(9999);
                    }
                }
                this.setBotoes(false);
                ((Mesa) this.jPMesa).repaint();
                break;
            case 501: // placarGeral
                this.jLMeusPontos.setText(recebida.getValor());
                break;
            case 502: //placarOponente
                this.jLPontosOponente.setText(recebida.getValor());
                this.criaBaralho();
                this.setBotoes(false);
                this.resultado1.setText("Acontecendo!");
                this.resultado2.setText("");
                this.resultado3.setText("");
                this.trucado = false;
                this.jBAcao.setEnabled(true);
                JOptionPane.showMessageDialog(this, "Placar:\nVocê: " + jLMeusPontos.getText() + "\n" + jLApelido.getText() + " " + jLPontosOponente.getText(), "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                break;
            case 550:
                if (recebida.getValor().equals("winner")) {
                    JOptionPane.showMessageDialog(this, "Você Venceu", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                } else {
                    JOptionPane.showMessageDialog(this, "Você Perdeu", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                }
                conectado = false;
                jMCriar.setEnabled(true);
                jMEntrar.setEnabled(true);
                for (Carta c : baralho) {
                    c.setOponente(false);
                    c.setDesenhar(false);
                    ((Mesa) this.jPMesa).repaint();
                }
                Mensagem fim = new Mensagem(101, "Fechei");
                ct.enviarMensagem(fim);
                break;
            case 667:
                valorTruco = Integer.parseInt(recebida.getValor());
                break;
            case 666:
                if (recebida.getValor().equals("Truco!")) {
                    respTruco = true;
                    this.setBotoes(false);
                    janelaTruco jp = new janelaTruco(this, true, apelidoOponente, "comum", 0);
                    jp.setLocationRelativeTo(this);
                    jp.setVisible(true);
                    String acao = jp.getAcao(); //Aceitar, Aumentar, Desisir
                    if (acao.equals("Aceitar")) {
                        ct.enviarMensagem(new Mensagem(666, "Aceitou!"));
                        this.trucado = true;
                        jBAcao.setEnabled(false);
                    }
                    if (acao.equals("Aumentar")) {
                        ct.enviarMensagem(new Mensagem(666, "Aumentou!"));
                    }
                    if (acao.equals("Desistir")) {
                        ct.enviarMensagem(new Mensagem(666, "Desistiu!"));
                    }
                }
                if (recebida.getValor().equals("Aceitou!")) {
                    respTruco = false;
                    this.setBotoes(false);
                    this.jBEmbaralhar.setEnabled(true);
                    this.trucado = true;
                    JOptionPane.showMessageDialog(this, apelidoOponente + " aceitou o Truco valendo " + valorTruco + " pontos!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                }
                if (recebida.getValor().equals("Aumentou!")) {
                    this.setBotoes(false);
                    janelaTruco jp = new janelaTruco(this, true, apelidoOponente, "aumentar", valorTruco); //arrumar
                    jp.setLocationRelativeTo(this);
                    jp.setVisible(true);
                    String acao = jp.getAcao(); //Aceitar, Aumentar, Desisir
                    if (acao.equals("Aceitar")) {
                        ct.enviarMensagem(new Mensagem(666, "Aceitou!"));
                        this.jBEmbaralhar.setEnabled(true);
                    }
                    if (acao.equals("Aumentar")) {
                        ct.enviarMensagem(new Mensagem(666, "Aumentou!"));
                    }
                    if (acao.equals("Desistir")) {
                        ct.enviarMensagem(new Mensagem(666, "Desistiu!"));
                    }
                }
                if (recebida.getValor().equals("Desistiu!")) {
                    respTruco = false;
                    JOptionPane.showMessageDialog(this, apelidoOponente + " desistiu do Truco!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                }
                break;
            case 668:
                JOptionPane.showMessageDialog(this, "Você pediu Truco com mao de 11!", "Mensagem", JOptionPane.INFORMATION_MESSAGE);
                break;
        }// fim do switch(cod)
    }

    public boolean isMinhaVez() {
        return minhaVez;
    }

    public void setMinhaVez(boolean minhaVez) {
        this.minhaVez = minhaVez;
    }

    public void setBotoes(boolean op) {
        if (this.minhaVez) {
            jBEmbaralhar.setEnabled(op);
            if (!trucado) {
                jBAcao.setEnabled(true);
                jBVirarCartas.setEnabled(op);
            } else {
                jBAcao.setEnabled(false);
                jBVirarCartas.setEnabled(op);
            }
        } else {
            jBAcao.setEnabled(false);
            jBEmbaralhar.setEnabled(false);
            jBVirarCartas.setEnabled(false);
        }
    }

    public String getMeusPontos() {
        return jLMeusPontos.getText();
    }

    public String getPontosOponente() {
        return jLPontosOponente.getText();
    }

    public boolean isMaquina() {
        return maquina;
    }

    public void setMaquina(boolean maquina) {
        this.maquina = maquina;
    }

    public boolean isRespTruco() {
        return respTruco;
    }

    public boolean isTrucado() {
        return trucado;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                new Principal().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBAcao;
    private javax.swing.JButton jBEmbaralhar;
    private javax.swing.JButton jBVirarCartas;
    private javax.swing.JLabel jLApelido;
    private javax.swing.JLabel jLMeusPontos;
    private javax.swing.JLabel jLPontosOponente;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLcaixa;
    private javax.swing.JMenuItem jMCriar;
    private javax.swing.JMenuItem jMEntrar;
    private javax.swing.JMenuItem jMSair;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JPanel jPLateral;
    private javax.swing.JPanel jPMesa;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel resultado1;
    private javax.swing.JLabel resultado2;
    private javax.swing.JLabel resultado3;
    private javax.swing.JLabel status;
    // End of variables declaration//GEN-END:variables
}
