package jogo;

import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.ArrayList;

public class ServidorThread extends Thread {

    private Socket conexao;
    Mensagem msg;
    private int num;
    ArrayList<Jogador> jogadores;
    Jogo jogo;
    private boolean jogando;
    private boolean cartaEscondida;
    private boolean vez; //true eh vez da saida; false eh vez da outra saida
    ObjectOutputStream saida;
    ObjectInputStream entrada;
    private boolean trucado;

    public ServidorThread(Socket c, ArrayList<Jogador> SaidaDosClientes, int num, Jogo jogo) {
        this.conexao = c;
        this.jogadores = SaidaDosClientes;
        this.num = num;
        this.jogo = jogo;
    }

    public void isVez() {
        vez = !vez;
        try {
            for (Jogador j : jogadores) {
                if (j.getSaida() == saida) {
                    if (this.vez) {
                        (j.getSaida()).writeObject(new Mensagem(201, "yes"));
                    } else {
                        (j.getSaida()).writeObject(new Mensagem(201, "no"));
                    }
                } else {
                    if (this.vez) {
                        (j.getSaida()).writeObject(new Mensagem(201, "no"));
                    } else {
                        (j.getSaida()).writeObject(new Mensagem(201, "yes"));
                    }
                }
            }
        } catch (IOException e) {
            System.err.println("Erro(ServidorThread).isVez: " + e.toString());
        }

    }

    @Override
    public void run() {

        try {
            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());
            this.jogadores.add(new Jogador("", saida));

            boolean conectado = true;

            while (conectado) {
                msg = (Mensagem) entrada.readObject();
                System.out.println(msg.getCodigo() + ": " + msg.getValor());
                int cod = msg.getCodigo();

                switch (cod) {
                    case 100: //Nome do jogador, entrar em jogo
                        if (num == 0) {
                            for (Jogador e : jogadores) {
                                if (e.getSaida() == saida) {
                                    e.setNome(msg.getValor());
                                }
                            }
                            System.err.println(msg.getValor() + " entrou!");
                            msg = new Mensagem(100, "");
                            saida.writeObject(msg);
                            num++;
                        } else {
                            for (Jogador e : jogadores) {
                                if (e.getSaida() == saida) {
                                    e.setNome(msg.getValor());
                                }
                            }
                            System.err.println(msg.getValor() + " entrou!");
                            msg = new Mensagem(100, msg.getValor());
                            for (Jogador e : jogadores) {
                                if (e.getSaida() != saida) {
                                    (e.getSaida()).writeObject(msg);
                                } else {
                                    for (Jogador j : jogadores) {
                                        if (j.getSaida() != saida) {
                                            msg.setValor(j.getNome());
                                        }
                                    }
                                    (e.getSaida()).writeObject(msg);
                                }
                            }
                            jogando = true;
                            msg = new Mensagem(202, ("" + jogo.getRodada()));
                            saida.writeObject(msg);
                            for (Jogador j : jogadores) {
                                if (j.getSaida() != saida) {
                                    (j.getSaida()).writeObject(msg);
                                }
                            }
                            for (Jogador j : jogadores) {
                                String cartasX = jogo.distribuir();
                                msg = new Mensagem(200, cartasX);
                                j.setCartas(cartasX);
                                (j.getSaida()).writeObject(msg);
                            }
                            this.isVez();
                        }

                        break;

                    case 101: //FIM,desconectar...
                        conectado = false;
                        for (Jogador e : jogadores) {
                            if (e.getSaida() != saida) { //FAZER
                                ObjectOutputStream outraSaida = e.getSaida();
                                outraSaida.writeObject(msg);
                            }
                        }
                        break;

                    case 210: // Jogador enviou uma carta
                        for (Jogador j : jogadores) {
                            if (!j.getCarta().equals("")) {
                                jogo.setJogada(jogo.getJogada() + 1);
                            }
                        }
                        switch (jogo.getJogada()) {
                            case 0:
                                if (msg.getValor().equals("00")) {
                                    cartaEscondida = true;
                                }
                                for (Jogador j : jogadores) {
                                    if (vez) {
                                        if (j.getSaida() == saida) {
                                            j.setCarta(msg.getValor());
                                        }
                                    } else {
                                        if (j.getSaida() != saida) {
                                            j.setCarta(msg.getValor());
                                        }
                                    }
                                }
                                for (Jogador j : jogadores) {
                                    if (vez) {
                                        if (j.getSaida() != saida) {
                                            (j.getSaida()).writeObject(new Mensagem(210, msg.getValor()));
                                        }
                                    } else {
                                        if (j.getSaida() == saida) {
                                            (j.getSaida()).writeObject(new Mensagem(210, msg.getValor()));
                                        }
                                    }
                                }
                                this.isVez();
                                break;
                            case 1:
                                //hauhauahuahao
                                for (Jogador j : jogadores) {
                                    if (j.getSaida() == saida) {
                                        j.setCarta(msg.getValor());
                                    }
                                    if (j.getSaida() != saida) {
                                        (j.getSaida()).writeObject(new Mensagem(210, msg.getValor()));
                                    }
                                }

                                String carta1 = "";
                                String carta2 = "";

                                for (Jogador j : jogadores) {
                                    if (j.getSaida() == saida) {
                                        carta1 = j.getCarta();
                                    } else {
                                        carta2 = j.getCarta();
                                    }
                                }
                                String resultado = jogo.verMaior(carta1, carta2);
                                if (resultado.equals(carta1)) {
                                    for (Jogador j : jogadores) {
                                        if (j.getSaida() == saida) {
                                            saida.writeObject(new Mensagem(500, "yes")); //voce ganhou
                                            j.setPlacarRodada(j.getPlacarRodada() + 1);
                                            saida.writeObject(new Mensagem(202, jogo.getRodada() + ":" + j.getPlacarRodada()));

                                        } else {
                                            (j.getSaida()).writeObject(new Mensagem(500, "no"));
                                            (j.getSaida()).writeObject(new Mensagem(202, jogo.getRodada() + ":" + j.getPlacarRodada()));
                                        }
                                    }
                                    jogo.setEmpate(false, jogo.getRodada());
                                }
                                if (resultado.equals(carta2)) {
                                    for (Jogador j : jogadores) {
                                        if (j.getSaida() == saida) {
                                            saida.writeObject(new Mensagem(500, "no"));
                                        } else {
                                            (j.getSaida()).writeObject(new Mensagem(500, "yes"));
                                            j.setPlacarRodada(j.getPlacarRodada() + 1);
                                        }
                                    }
                                    jogo.setEmpate(false, jogo.getRodada());
                                }
                                if (resultado.equals("empate")) {
                                    for (Jogador j : jogadores) {
                                        (j.getSaida()).writeObject(new Mensagem(500, "empate"));
                                    }
                                    jogo.setEmpate(true, jogo.getRodada());
                                }
                                for (Jogador j : jogadores) {
                                    (j.getSaida()).writeObject(new Mensagem(202, jogo.getRodada() + ":" + j.getPlacarRodada()));
                                }

                                // teste
                                if (jogo.getRodada() > 0) {
                                    if (jogo.getEmpate(0)) {
                                        System.err.println("1");
                                        if (!jogo.getEmpate(1)) {
                                            System.err.println("2");
                                            //acabar
                                            jogo.setAcabar(true);
                                        }
                                    }
                                    if (jogo.getEmpate(1)) {
                                        System.err.println("3");
                                        if (!jogo.getEmpate(0)) {
                                            System.err.println("4");
                                            //acabar
                                            jogo.setAcabar(true);
                                        }
                                    }
                                    if (!jogo.getEmpate(0)) {
                                        if (!jogo.getEmpate(1)) {
                                            int pon1 = 0;
                                            int pon2 = 0;
                                            for (Jogador j : jogadores) {
                                                if (j.getSaida() == saida) {
                                                    pon1 = j.getPlacarRodada();
                                                } else {
                                                    pon2 = j.getPlacarRodada();
                                                }
                                            }
                                            if (pon1 != pon2) {
                                                jogo.setAcabar(true);
                                            }
                                        }
                                    }
                                    for (int i = 0; i < 3; i++) {
                                        System.err.println("resultados[" + i + "] = " + jogo.getEmpate(i));
                                    }
                                }
                                //teste
                                System.err.println("ACABAR=" + jogo.isAcabar());
                                System.err.println("RODADA=" + jogo.getRodada());
                                System.err.println("resultado: " + jogo.getEmpate(jogo.getRodada()));
                                this.isVez();
                                if (!jogo.isAcabar()) {
                                    jogo.nextRodada();
                                } else {
                                    for (int i = 0; i < 3; i++) {
                                        jogo.setEmpate(false, i);
                                    }
                                    jogo.setRodada(0);
                                    jogo.setAcabar(false);
                                }
                                if (jogo.getRodada() == 0) {
                                    int pon1 = 0;
                                    int pon2 = 0;
                                    for (Jogador j : jogadores) {
                                        if (j.getSaida() == saida) {
                                            pon1 = j.getPlacarRodada();
                                        } else {
                                            pon2 = j.getPlacarRodada();
                                        }
                                    }
                                    if (pon1 > pon2) { //pontua jogador vencedor (saida)
                                        for (Jogador j : jogadores) {
                                            if (j.getSaida() == saida) {
                                                j.setPlacarGeral(j.getPlacarGeral() + jogo.getValorTruco());
                                            }
                                        }
                                    } else {
                                        if (pon2 > pon1) { //pontua jogador vencedor (outraSaida)
                                            for (Jogador j : jogadores) {
                                                if (j.getSaida() != saida) {
                                                    j.setPlacarGeral(j.getPlacarGeral() + jogo.getValorTruco());
                                                }
                                            }
                                        } else {
                                            String[] c = new String[2];
                                            int[] n = new int[2];
                                            for (Jogador j : jogadores) {
                                                if (j.getSaida() == saida) {
                                                    c[0] = j.getCarta();
                                                } else {
                                                    c[1] = j.getCarta();
                                                }
                                            }
                                            for (int i = 0; i < 2; i++) {
                                                if (("" + c[i].charAt(1)).equals("o")) {
                                                    n[i] = 1;
                                                }
                                                if (("" + c[i].charAt(1)).equals("e")) {
                                                    n[i] = 2;
                                                }
                                                if (("" + c[i].charAt(1)).equals("c")) {
                                                    n[i] = 3;
                                                }
                                                if (("" + c[i].charAt(1)).equals("p")) {
                                                    n[i] = 4;
                                                }
                                            }

                                            if (n[0] > n[1]) { //atualiza o placar de cada jogador (+1 para cada) (empate)
                                                for (Jogador j : jogadores) {
                                                    if (j.getSaida() == saida) {
                                                        j.setPlacarGeral(j.getPlacarGeral() + jogo.getValorTruco());
                                                    }
                                                }
                                            } else {
                                                for (Jogador j : jogadores) {
                                                    if (j.getSaida() != saida) {
                                                        j.setPlacarGeral(j.getPlacarGeral() + jogo.getValorTruco());
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    int placar = 0, placar2 = 0;
                                    for (Jogador j : jogadores) {
                                        if (j.getSaida() == saida) {
                                            placar = j.getPlacarGeral();
                                        } else {
                                            placar2 = j.getPlacarGeral();
                                        }
                                    }
                                    for (Jogador j : jogadores) { //Manda o placar
                                        if (j.getSaida() == saida) {
                                            (j.getSaida()).writeObject(new Mensagem(501, "" + j.getPlacarGeral()));
                                            (j.getSaida()).writeObject(new Mensagem(502, "" + placar2));
                                            j.setPlacarRodada(0);
                                        } else {
                                            (j.getSaida()).writeObject(new Mensagem(501, "" + j.getPlacarGeral()));
                                            (j.getSaida()).writeObject(new Mensagem(502, "" + placar));
                                            j.setPlacarRodada(0);
                                        }
                                    }
                                    jogo.criaBaralho();
                                    for (Jogador j : jogadores) { //distribui novas cartas
                                        String cartasX = jogo.distribuir();
                                        msg = new Mensagem(200, cartasX);
                                        j.setCartas(cartasX);
                                        (j.getSaida()).writeObject(msg);
                                    }
                                    jogo.setValorTruco(1);
                                    this.trucado = false;
                                }
                                jogo.setJogada(0);
                                for (Jogador j : jogadores) {
                                    j.setCarta("");
                                }
                                int[] placar = new int[2];
                                for (Jogador j : jogadores) {
                                    if (j.getSaida() == saida) {
                                        placar[0] = j.getPlacarGeral();
                                    } else {
                                        placar[1] = j.getPlacarGeral();
                                    }
                                }
                                if (placar[0] >= 12) {
                                    for (Jogador j : jogadores) {
                                        if (j.getSaida() == saida) {
                                            (j.getSaida()).writeObject(new Mensagem(550, "winner"));
                                        } else {
                                            (j.getSaida()).writeObject(new Mensagem(550, "loser"));
                                        }
                                    }
                                }
                                if (placar[1] >= 12) {
                                    for (Jogador j : jogadores) {
                                        if (j.getSaida() != saida) {
                                            (j.getSaida()).writeObject(new Mensagem(550, "winner"));
                                        } else {
                                            (j.getSaida()).writeObject(new Mensagem(550, "loser"));
                                        }
                                    }
                                }
                                break;
                        }
                        break;
                    case 666:
                        if (msg.getValor().equals("Truco!")) {
                            int[] placar = new int[2];
                            int jk = 0;
                            for (Jogador j : jogadores) {
                                if (j.getSaida() == saida) {
                                    placar[0] = j.getPlacarGeral();
                                } else {
                                    placar[1] = j.getPlacarGeral();
                                }
                            }
                            int resp = 0;
                            if (placar[0] == 11 && placar[1] != 11) {
                                resp = 1;
                            }
                            if (placar[1] == 11 && placar[0] != 11) {
                                resp = 2;
                            }
                            for (Jogador j : jogadores) {
                                if (resp == 1) {
                                    if (j.getSaida() == saida) {
                                        (j.getSaida()).writeObject(new Mensagem(668, ""));
                                        (j.getSaida()).writeObject(new Mensagem(550, "loser"));
                                    } else {
                                        (j.getSaida()).writeObject(new Mensagem(550, "winner"));
                                    }
                                }
                                if (resp == 2) {
                                    if (j.getSaida() != saida) {
                                        (j.getSaida()).writeObject(new Mensagem(668, ""));
                                        (j.getSaida()).writeObject(new Mensagem(550, "loser"));
                                    } else {
                                        (j.getSaida()).writeObject(new Mensagem(550, "winner"));
                                    }
                                }
                            }
                            if (resp == 0) {
                                for (Jogador j : jogadores) {
                                    if (j.getSaida() != saida) {
                                        (j.getSaida()).writeObject(new Mensagem(667, "" + jogo.getValorTruco()));
                                        (j.getSaida()).writeObject(new Mensagem(666, "Truco!"));
                                    }
                                }
                                this.trucado = true;
                            }
                        }
                        if (msg.getValor().equals("Aceitou!")) {
                            if (jogo.getValorTruco() == 1) {
                                jogo.setValorTruco(3);
                            }
                            for (Jogador j : jogadores) {
                                if (j.getSaida() != saida) {
                                    (j.getSaida()).writeObject(new Mensagem(667, "" + jogo.getValorTruco()));
                                    (j.getSaida()).writeObject(new Mensagem(666, "Aceitou!"));
                                }
                            }
                        }
                        if (msg.getValor().equals("Aumentou!")) {
                            if (jogo.getValorTruco() == 1) {
                                jogo.setValorTruco(6);
                            } else {
                                jogo.setValorTruco(jogo.getValorTruco() + 3);
                            }
                            for (Jogador j : jogadores) {
                                if (j.getSaida() != saida) {
                                    (j.getSaida()).writeObject(new Mensagem(667, "" + jogo.getValorTruco()));
                                    (j.getSaida()).writeObject(new Mensagem(666, "Aumentou!"));
                                }
                            }
                        }
                        if (msg.getValor().equals("Desistiu!")) {
                            for (Jogador j : jogadores) {
                                if (j.getSaida() != saida) {
                                    (j.getSaida()).writeObject(new Mensagem(666, "Desistiu!"));
                                    if (jogo.getValorTruco() > 1) {
                                        jogo.setValorTruco(jogo.getValorTruco() - 3);
                                    }
                                }
                            }
                            this.trucado = false;
                            this.isVez();
                            jogo.nextRodada();

                            int placar = 0, placar2 = 0;
                            for (Jogador j : jogadores) {
                                if (j.getSaida() == saida) {
                                    j.setPlacarGeral(j.getPlacarGeral());
                                    placar = j.getPlacarGeral();
                                } else {
                                    j.setPlacarGeral(j.getPlacarGeral() + jogo.getValorTruco());
                                    placar2 = j.getPlacarGeral();
                                }
                            }
                            for (Jogador j : jogadores) { //Manda o placar
                                if (j.getSaida() == saida) {
                                    (j.getSaida()).writeObject(new Mensagem(501, "" + j.getPlacarGeral()));
                                    (j.getSaida()).writeObject(new Mensagem(502, "" + placar2));
                                    j.setPlacarRodada(0);
                                } else {
                                    (j.getSaida()).writeObject(new Mensagem(501, "" + j.getPlacarGeral()));
                                    (j.getSaida()).writeObject(new Mensagem(502, "" + placar));
                                    j.setPlacarRodada(0);
                                }
                            }
                            jogo.criaBaralho();
                            for (Jogador j : jogadores) { //distribui novas cartas
                                String cartasX = jogo.distribuir();
                                msg = new Mensagem(200, cartasX);
                                j.setCartas(cartasX);
                                (j.getSaida()).writeObject(msg);
                            }
                            jogo.setValorTruco(1);
                            this.trucado = false;
                            jogo.setJogada(0);
                            for (Jogador j : jogadores) {
                                j.setCarta("");
                            }
                            int[] placar1 = new int[2];
                            for (Jogador j : jogadores) {
                                if (j.getSaida() == saida) {
                                    placar1[0] = j.getPlacarGeral();
                                } else {
                                    placar1[1] = j.getPlacarGeral();
                                }
                            }
                            if (placar1[0] >= 12) {
                                for (Jogador j : jogadores) {
                                    if (j.getSaida() == saida) {
                                        (j.getSaida()).writeObject(new Mensagem(550, "winner"));
                                    } else {
                                        (j.getSaida()).writeObject(new Mensagem(550, "loser"));
                                    }
                                }
                            }
                            if (placar1[1] >= 12) {
                                for (Jogador j : jogadores) {
                                    if (j.getSaida() != saida) {
                                        (j.getSaida()).writeObject(new Mensagem(550, "winner"));
                                    } else {
                                        (j.getSaida()).writeObject(new Mensagem(550, "loser"));
                                    }
                                }
                            }
                        }

                        break;
                } // fim do switch(cod)
            } // fim do while(conectado)
            // fechando os fluxos e a conexao
            saida.close();
            entrada.close();
            conexao.close();
        } catch (EOFException e) {
            try {
                saida.close();
                entrada.close();
                conexao.close();
            } catch (Exception ex) {
                System.err.println("Erro ao fechar conexoes(EOFException): " + ex.toString());
            }
        } catch (Exception ex) {
            System.err.println("Erro sockets(ServidorThread): " + ex.toString());
        }


    }
}
